GlobalHistogramBinarizer (ZXing 3.5.0 API)

com.google.zxing.common

## Class GlobalHistogramBinarizer

- java.lang.Object
- - com.google.zxing.Binarizer
  - - com.google.zxing.common.GlobalHistogramBinarizer

- Direct Known Subclasses:
    HybridBinarizer

      public class GlobalHistogramBinarizer
      extends Binarizer

  This Binarizer implementation uses the old ZXing global histogram approach. It is suitable for low-end mobile devices which don't have enough CPU or memory to use a local thresholding algorithm. However, because it picks a global black point, it cannot handle difficult shadows and gradients. Faster mobile devices and all desktop applications should probably use HybridBinarizer instead.
  Author:
    dswitkin@google.com (Daniel Switkin), Sean Owen

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `GlobalHistogramBinarizer(LuminanceSource source)`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `Binarizer` | `createBinarizer(LuminanceSource source)` Creates a new object with the same type as this Binarizer implementation, but with pristine state.
    `BitMatrix` | `getBlackMatrix()` Converts a 2D array of luminance data to 1 bit data.
    `BitArray` | `getBlackRow(int y, BitArray row)` Converts one row of luminance data to 1 bit data.

    - ### Methods inherited from class com.google.zxing.Binarizer

      `getHeight, getLuminanceSource, getWidth`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### GlobalHistogramBinarizer

          public GlobalHistogramBinarizer(LuminanceSource source)

  - ### Method Detail

    - #### getBlackRow

          public BitArray getBlackRow(int y,
                                      BitArray row)
                               throws NotFoundException

      Description copied from class: `Binarizer`
      Converts one row of luminance data to 1 bit data. May actually do the conversion, or return cached data. Callers should assume this method is expensive and call it as seldom as possible. This method is intended for decoding 1D barcodes and may choose to apply sharpening. For callers which only examine one row of pixels at a time, the same BitArray should be reused and passed in with each call for performance. However it is legal to keep more than one row at a time if needed.
      Specified by:
        `getBlackRow` in class `Binarizer`
      Parameters:
        `y` - The row to fetch, which must be in [0, bitmap height)
        `row` - An optional preallocated array. If null or too small, it will be ignored. If used, the Binarizer will call BitArray.clear(). Always use the returned object.
      Returns:
        The array of bits for this row (true means black).
      Throws:
        `NotFoundException` - if row can't be binarized

    - #### getBlackMatrix

          public BitMatrix getBlackMatrix()
                                   throws NotFoundException

      Description copied from class: `Binarizer`
      Converts a 2D array of luminance data to 1 bit data. As above, assume this method is expensive and do not call it repeatedly. This method is intended for decoding 2D barcodes and may or may not apply sharpening. Therefore, a row from this matrix may not be identical to one fetched using getBlackRow(), so don't mix and match between them.
      Specified by:
        `getBlackMatrix` in class `Binarizer`
      Returns:
        The 2D array of bits for the image (true means black).
      Throws:
        `NotFoundException` - if image can't be binarized to make a matrix

    - #### createBinarizer

          public Binarizer createBinarizer(LuminanceSource source)

      Description copied from class: `Binarizer`
      Creates a new object with the same type as this Binarizer implementation, but with pristine state. This is needed because Binarizer implementations may be stateful, e.g. keeping a cache of 1 bit data. See Effective Java for why we can't use Java's clone() method.
      Specified by:
        `createBinarizer` in class `Binarizer`
      Parameters:
        `source` - The LuminanceSource this Binarizer will operate on.
      Returns:
        A new concrete Binarizer implementation object.

Copyright © 2007–2022. All rights reserved.